import { J as Json, O as ObjectStorage, L as LogHandlerOptions, cQ as LogMessage, a as LogHandler } from './uuid-1dec8bcb.js';
export { dq as ArgumentsType, cj as AsyncMutex, V as BinInput, c_ as Channel, cZ as ChannelMessageEvent, dc as CryptoEncoder, at as Currency, ar as CurrencyInput, au as DAY_MS, aR as Day, aw as DayInput, aQ as DayInputLegacy, av as DayValue, aX as DecimalInput, aW as DecimalValue, d4 as DefaultListener, c9 as Disposable, c8 as Disposer, c7 as DisposerFunction, d5 as Emitter, d2 as EmitterAllHandler, d1 as EmitterHandler, d9 as Encoder, J as Json, db as JsonEncoder, d3 as ListenerSignature, c$ as LocalChannel, a as LogHandler, L as LogHandlerOptions, c as LogLevel, cN as LogLevelAlias, cO as LogLevelAliasKey, cP as LogLevelAliasType, cQ as LogMessage, cM as Logger, cT as LoggerConsoleHandler, cS as LoggerContext, cR as LoggerContextInterface, b as LoggerInterface, cY as LoggerMemoryHandler, dM as MemStorage, dL as MemStorageOptions, df as Message, dd as MessageAction, dj as MessageDefinitions, dk as MessageHub, de as MessageResult, dh as MessagesDefaultMethods, di as MessagesMethods, dg as MessagesOptions, ci as Mutex, dQ as NestedArray, da as NoopEncoder, O as ObjectStorage, cs as Pool, co as PoolTask, cq as PoolTaskEvents, cm as PoolTaskFn, cp as PoolTaskIdConflictResolution, cn as PoolTaskState, b5 as Primitive, dn as PubSub, dt as RPCFn, ds as RPCOptions, du as RPCReturn, an as RenderMessagesOptions, dr as ReturnType, bC as RoundingMode, cG as SerialQueue, bN as SortableItem, cF as TaskEvents, cE as TaskFn, a7 as Uint8ArrayToHexDump, a6 as Uint8ArrayToJson, Y as Uint8ArrayToString, ce as UseDefer, cb as UseDispose, c6 as XRX, W as _decodeUtf8Polyfill, _ as _encodeUtf8Polyfill, E as arrayAvg, F as arrayBatches, t as arrayEmptyInPlace, q as arrayFilterInPlace, l as arrayFlatten, m as arrayIntersection, w as arrayIsEqual, B as arrayMax, C as arrayMin, j as arrayMinus, A as arrayRandomElement, o as arrayRemoveElement, p as arraySetElement, y as arrayShuffle, z as arrayShuffleForce, x as arrayShuffleInPlace, u as arraySorted, v as arraySortedNumbers, D as arraySum, n as arraySymmetricDifference, s as arrayToggleInPlace, k as arrayUnion, i as arrayUnique, br as avg, bp as between, c0 as cloneJsonObject, b$ as cloneObject, by as cmp, bx as composeOrderby, G as createArray, d0 as createLocalChannelPair, ct as createPromise, dl as createPromiseProxy, h as csv, as as currency, aV as dateStringToDays, aU as day, az as dayDay, aP as dayDiff, aD as dayFromAny, aF as dayFromDate, aG as dayFromDateGMT, aK as dayFromParts, aL as dayFromString, aI as dayFromTimestamp, aC as dayFromToday, ay as dayMonth, aM as dayMonthStart, aO as dayOffset, aB as dayToDate, aE as dayToDateGMT, aA as dayToParts, aJ as dayToString, aH as dayToTimestamp, ax as dayYear, aN as dayYearStart, cI as debounce, aY as decimal, a$ as decimalCentsPart, aZ as decimalFromCents, a_ as decimalToCents, K as decodeBase16, N as decodeBase32, Q as decodeBase58, S as decodeBase62, U as decodeBase64, g as decrypt, b0 as deepEqual, b2 as deepMerge, b1 as deepStripUndefinedInPlace, e as deriveKeyPbkdf2, dH as detect, d as digest, b_ as empty, I as encodeBase16, M as encodeBase32, P as encodeBase58, R as encodeBase62, T as encodeBase64, bU as encodeQuery, f as encrypt, bP as endSortWeight, bW as ensureKey, bX as ensureKeyAsync, a4 as equalBinary, b3 as escapeHTML, bB as escapeRegExp, dy as fetchBasic, dz as fetchJson, dD as fetchOptionsBasicAuth, dB as fetchOptionsFormURLEncoded, dC as fetchOptionsJson, dA as fetchText, aq as fixBrokenUth8String, aS as forEachDay, c3 as forTimes, ao as formatMessages, dO as formatMilliseconds, a3 as fromBase64, ab as fromCamelCase, dG as getGlobal, cJ as getGlobalContext, d6 as getGlobalEmitter, cL as getGlobalLogger, cU as getNamespaceFilterString, dF as getNavigator, bk as getSecureRandom, bl as getSecureRandomIfPossible, dN as getTimestamp, dE as getWindow, dw as httpMethod, cv as immediate, b8 as isArray, be as isBoolean, dI as isBrowser, bE as isEven, bD as isHalf, bc as isInteger, cK as isLocalHost, bf as isNullOrUndefined, bb as isNumber, b6 as isObject, bt as isPrime, bs as isPrimeRX, b7 as isPrimitive, cC as isPromise, b9 as isRecord, bd as isSafeInteger, ba as isString, cz as isTimeout, bg as isUint8Array, $ as joinToUint8Array, bj as jsonStringify, bi as jsonStringifySafe, bh as jsonStringifySorted, a5 as jsonToUint8Array, bZ as last, d8 as lazyListener, bS as linkifyPlainText, c1 as memoize, c2 as memoizeAsync, d7 as messages, bQ as moveSortWeight, bv as objectMap, dx as parseBasicAuth, dP as parseDate, cW as parseLogLevel, bw as parseOrderby, bV as parseQuery, dJ as platform, cD as promisify, d_ as qid, bm as randomBoolean, bo as randomFloat, bn as randomInt, r as randomUint8Array, c5 as regExpEscape, c4 as regExpString, ap as renderMessages, bG as roundDown, bJ as roundHalfAwayFromZero, bK as roundHalfDown, bL as roundHalfEven, bI as roundHalfOdd, bM as roundHalfTowardsZero, bH as roundHalfUp, bF as roundUp, bu as seededRandom, bY as size, cu as sleep, bR as sortedItems, bz as sortedOrderby, bO as startSortWeight, ac as stringToBoolean, ae as stringToFloat, ad as stringToInteger, X as stringToUInt8Array, e1 as suid, e0 as suidBytes, e3 as suidBytesDate, e2 as suidDate, bq as sum, cH as throttle, cx as timeout, cw as timeoutReached, cy as timoutError, a1 as toBase64, a2 as toBase64Url, am as toBool, a8 as toCamelCase, a9 as toCapitalize, aa as toCapitalizeWords, aj as toFloat, a0 as toHex, bT as toHumanReadableUrl, ak as toInt, al as toString, Z as toUint8Array, bA as toValidFilename, aT as today, cA as tryTimeout, dZ as uname, b4 as unescapeHTML, cl as useAsyncMutex, H as useBase, cd as useDefer, ca as useDispose, cc as useDisposer, ch as useEventListener, dK as useExitHandler, cg as useInterval, cX as useLevelFilter, dm as useMessageHub, ck as useMutex, cV as useNamespaceFilter, cr as usePool, dp as usePubSub, dv as useRPC, cf as useTimeout, dT as uuid, dY as uuid32Decode, dX as uuid32Encode, dS as uuid32bit, dW as uuidB32, dR as uuidBytes, dV as uuidDecode, dU as uuidEncode, d$ as uuidv4, af as valueToBoolean, ah as valueToFloat, ag as valueToInteger, ai as valueToString, cB as waitOn } from './uuid-1dec8bcb.js';

interface ParseConfig {
    args?: string[];
    alias?: Record<string, string[]>;
    normalize?: (value: string) => string;
    booleanArgs?: string | string[];
    listArgs?: string | string[];
    numberArgs?: string | string[];
}
declare function parseArgs(config?: ParseConfig): Record<string, any>;

/** Copy string to clipboard */
declare function pbcopy(data: string): Promise<unknown>;

declare type csvOptions = {
    /** @deprecated will probably be replaced by logLevel */
    debug?: boolean;
    path?: string;
    filename?: string;
    encoding?: BufferEncoding;
    prefix?: string;
    env?: Record<string, string>;
};
/**
 * Return a path relative to the current working directory
 */
declare function stringToPath(value?: string, defaultValue?: string): string;
declare function valueToPath(value?: any, defaultValue?: string): string;
declare const toPath: typeof valueToPath;
declare function getEnvVariableRelaxed(name: string, env?: NodeJS.ProcessEnv): string | undefined;
/** Populates process.env from .env file. */
declare function setupEnv(options?: csvOptions): {
    parsed: Record<string, string>;
    error?: undefined;
} | {
    error: unknown;
    parsed?: undefined;
};

interface FileStorageOptions {
    pretty?: boolean;
    path?: string;
    extension?: string;
    objectFromString?: (data: string) => any;
    objectToString?: (data: any) => string;
    keyToFilename?: (key: string) => string;
}
declare class FileStorage<T = Json> implements ObjectStorage<T> {
    private store;
    private dirname;
    private fileKeys?;
    private pretty;
    private extension;
    private extensionLength;
    private objectFromString;
    private objectToString;
    private keyToFilename;
    constructor(opt?: FileStorageOptions);
    setItem(key: string, value: T): void;
    getPath(key: string): string;
    getBuffer(key: string): Buffer;
    getItem(key: string): T | undefined;
    removeItem(key: string): void;
    clear(): void;
    allKeys(): string[];
}

declare function toHumanReadableFilePath(path: string): string;
declare function exists(path: string): Promise<boolean>;
declare function ensureFolder(...parts: string[]): Promise<string>;
declare function removeFolder(...parts: string[]): Promise<string>;
declare function readText(...parts: string[]): Promise<string | undefined>;
declare function writeText(path: string, content: string): Promise<void>;

declare function LoggerFileHandler(path: string, opt?: LogHandlerOptions): (msg: LogMessage) => void;

declare function colorString(text: string, colorCode: number): string;
declare function colorStringList(list: Array<any>, style: string, bold?: boolean): any[];
declare const loggerStackTraceDebug = "loggerStackTraceDebug-7d38e5a9214b58d29734374cdb9521fd964d7485";
declare function LoggerNodeHandler(opt?: LogHandlerOptions): LogHandler;

declare function getStackLlocationList(stack: string): any[];
/**
 * Get the source code location of the caller
 * https://stackoverflow.com/a/47296370/140927
 *
 * @param level Number of levels to go down the stack trace
 * @param stripCwd Strip the current working directory, only reasonable for Node.js environment
 * @returns
 */
declare function getSourceLocation(level?: number, stripCwd?: boolean): string;
declare function getStack(): string;
declare function getSourceLocationByPrecedingPattern(patterns: string[], stripCwd?: boolean): string;

export { FileStorage, FileStorageOptions, LoggerFileHandler, LoggerNodeHandler, colorString, colorStringList, ensureFolder, exists, getEnvVariableRelaxed, getSourceLocation, getSourceLocationByPrecedingPattern, getStack, getStackLlocationList, loggerStackTraceDebug, parseArgs, pbcopy, readText, removeFolder, setupEnv, stringToPath, toHumanReadableFilePath, toPath, valueToPath, writeText };
